/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest{}

// AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest struct for AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest
type AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest struct {
	Config *GoogleBigQueryCustomDtoAuthorizer `json:"config,omitempty"`
}

// NewAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest instantiates a new AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest() *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest {
	this := AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest{}
	return &this
}

// NewAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequestWithDefaults instantiates a new AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequestWithDefaults() *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest {
	this := AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest{}
	return &this
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) GetConfig() GoogleBigQueryCustomDtoAuthorizer {
	if o == nil || IsNil(o.Config) {
		var ret GoogleBigQueryCustomDtoAuthorizer
		return ret
	}
	return *o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) GetConfigOk() (*GoogleBigQueryCustomDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given GoogleBigQueryCustomDtoAuthorizer and assigns it to the Config field.
func (o *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) SetConfig(v GoogleBigQueryCustomDtoAuthorizer) {
	o.Config = &v
}

func (o AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest struct {
	value *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) Get() *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) Set(val *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest(val *AppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) *NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest {
	return &NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleBigQueryCustomGoogleBigQueryCustomAuthorizerNewOAuthUrlRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
